<%--
 * Component: cd
 *
 * Description:
 *     Downloads studies prepared for DICOM media from hubs.
 *     Studies will be packed up to a tar.gz file
 *
 * @param cMediaSession : ID of the media session 
 *   
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@
	page import="java.io.*, java.util.*, java.sql.*, imagemed.dotcom.*, imagemed.http.Range, imagemed.dicom.DicomMediaSession,
			imagemed.imsession.*, imagemed.util.*, java.nio.file.*"

%><%

	IMSession is = new IMSession( request, response, out );

	try {
		Properties prpPeer = imagemed.jsputil.DotcomToolbox.checkClient( is, null, false );
		if ( prpPeer != null ) {
			String deviceID = prpPeer.getProperty( "ID", "" );
			if ( "".equals( deviceID ) ) {
				throw new Throwable();
			}
		}
	}
	catch ( Throwable th ) {
//		response.sendError( 500, "Request rejected" );
//		return;
	}

	String parMediaSession = request.getParameter( "cMediaSession" );
	if ( parMediaSession == null ) {
		response.sendError( 500, "Missing parameters" );
		return;
	}

	File sessionDir = new File( DicomMediaSession.MEDIA_TEMP_DIR, DicomMediaSession.MEDIA_SESSION_PREFIX + parMediaSession );
	if ( !sessionDir.exists() ) {
		response.sendError( 404, "Media session directory does not exist" );
		return;
	}

	File studiesDir = new File( sessionDir, "studies" );
	if ( !studiesDir.exists() ) {
		response.sendError( 404, "Media content directory does not exist" );
		return;
	}

	File uploadFile = new File( sessionDir, "content_upload.tar.gz" );
	if ( !uploadFile.exists() ) {
		Vector<String> cmd = new Vector<String>();
		String studiesDirAbsolutePath = studiesDir.getAbsolutePath();
		
		cmd.add( "tar" );
		cmd.add( "czf" );
		cmd.add( uploadFile.getAbsolutePath() );
		cmd.add( "-C" );
		cmd.add( studiesDirAbsolutePath );

		boolean hasStudy = false;
		try (DirectoryStream<Path> ds = Helper.getDirectoryStream( studiesDirAbsolutePath )) {
			if( ds == null ){
				response.sendError( 404, "Media content directory is empty" );
				return;
			}
			
			for ( Path path : ds ) {
				Path fileNamePath = path.getFileName();
				if ( Files.isDirectory( path ) && ( fileNamePath != null ) ){
					hasStudy = true;
					cmd.add( fileNamePath.toString() );
				}
			}
		}
		catch( IOException e ) {
		}

		if ( !hasStudy ) {
			response.sendError( 404, "Media content directory contains no study directories" );
			return;
		}

		RunCommandResult res = Helper.runCommandEx( cmd.toArray( new String[ cmd.size() ] ), null ); 
		if ( res.getExitCode() != 0 ) {
			response.sendError( 500, "Packaging media content failed: " + res.getError() );
			return;
		}
	}
	
	
	Range range = new Range( request, response );
	range.sendRequestedRange( uploadFile.getAbsolutePath() );

%><%-- TODO: remove tar file if no longer needed--%><%
	
	if (true) {
		// For avoiding extra new lines to be printed
		return;
	}
%>
